package cn.flea.chexnetmaster.service.impl;

import cn.flea.chexnetmaster.service.ContentCheckService;
import cn.flea.chexnetmaster.util.WeiXinUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.util.Map;

@Slf4j
@Service
public class ContentCheckServiceA implements ContentCheckService {
    @Autowired
    private WeiXinUtil weiXinUtil;

    /**
     * 文本检测, 返回0为检测失败，1为文本正常，2为文本违规
     *
     * @param text
     * @param openid
     * @return
     */
    @Override
    public Integer textCheck(String text, String openid) {
        Map<String, Object> map = weiXinUtil.textCheck(text, openid);
        log.info(text + "文本检测结果: " + map);

        try {
            Integer res = ((Double) map.get("errcode")).intValue();
            if (res == 0) {
                map = (Map<String, Object>) map.get("result");
                if (map.get("suggest").equals("pass")) return 1;
                return 2;
            }
        } catch (Exception e) {

        }

        return 0;
    }

    /**
     * 图片检测, 返回0为检测失败，1为图片正常，2为图片违规
     *
     * @param img
     * @param openid
     * @return
     */

    @Override
    public Integer imgCheck(MultipartFile img, String openid) {
        Map<String, Object> map = weiXinUtil.imgCheck(img);
        log.info("图片检测结果: " + map);

        try {
            Integer res = ((Double) map.get("errcode")).intValue();
            if (res == 0) return 1;
            if (res == 87014) return 2;
        } catch (Exception e) {

        }

        return 0;
    }
}
